/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	clock.h,v $
 * Revision 2.3  92/05/21  17:17:53  jfriedl
 * 	moved dmsize[] to clock.c
 * 	[92/05/21  15:59:24  jfriedl]
 * 
 * Revision 2.2  91/07/09  23:16:45  danner
 * 	Added CLOCK_INTR_HZ, the frequency of the system interrupt clock.
 * 	[91/05/10            danner]
 * 
 * Revision 2.2  91/04/05  14:01:21  mbj
 * 	Initial code from the Omron 1.10 kernel release corresponding to X130.
 * 	The Copyright has been adjusted to correspond to the understanding
 * 	between CMU and the Omron Corporation.
 * 	[91/04/04            rvb]
 * 
 */

/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)clock.h	7.1 (Berkeley) 6/5/86
 */

#define SECDAY		((unsigned)(24*60*60))		/* seconds per day */
#define SECYR		((unsigned)(365*SECDAY))	/* per common year */

/*
 * TIME KEEPER RAM -- (MK48T02/12(B)-12/15/20/25)
 *	Integrated Ultr Low Power SRAM, Real Time Clock,
 *	Crystal, Power-fail Control Circuit and Buattery.
 */
#define	RTC_FRQ		0x40		/* Frequency test (in day) */
#define	RTC_KICK	0x80		/* Kick start (in hour) */
#define	RTC_STOP	0x80		/* Stop bit (in seconds) */
#define	RTC_WRT		0x80		/* Write bit (in control) */
#define	RTC_RD		0x40		/* Read bit (in control) */
#define	RTC_SGN		0x20		/* Sign bit (in control) */
#define	RTC_DELAY	180		/* delay time */

#define CLOCK_INTR_HZ   100             /* 100 hz system clock */
