/* 
 * Mach Operating System
 * Copyright (c) 1991, 1992 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon 
 * the rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	lcd.h,v $
 * Revision 2.2  92/08/03  17:42:04  jfriedl
 * 	created.
 * 	[92/07/24            jfriedl]
 * 
 */

/*
 * LCD driver
 */
#ifndef __LCD_H__
#define __LCD_H__

/*
 * When writing to the LCD device, LCD_CTRL indicates that the
 * next byte is a command character code.
 */
#define LCD_CTRL  0x01

/*
 * The following are LCD device command codes.
 */
#define LCD_CLS_CMD     0x01    /* clear LCD display */
#define LCD_HOME_CMD    0x02    /* cursor to upper-left of display */
#define LCD_ENTRY_CMD   0x06
#define LCD_ON_CMD      0x0c	/* Turn display on */
#define LCD_INIT_CMD    0x38

#endif /* __LCD_H__ */
