/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	asm_utils.h,v $
 * Revision 2.2  91/07/09  23:17:33  danner
 * 	Initial 3.0 Checkin
 * 	[91/06/26  11:59:58  danner]
 * 
 * Revision 2.2  91/04/05  14:02:46  mbj
 * 	Initial code from the Omron 1.10 kernel release corresponding to X130.
 * 	The Copyright has been adjusted to correspond to the understanding
 * 	between CMU and the Omron Corporation.
 * 	[91/04/04            rvb]
 * 
 */

#ifndef __asm_h_included__	/* standard "include-me-once" wrapper */
#define __asm_h_included__

/*
 * Gives the return address to the current function, IF the function
 * has a proper execption frame.
 * If not, try "current_r1".
 */
#define return_addr						\
	({							\
		void (*__foo_)();				\
		asm("ld %0, r30, 4" : "=r" (__foo_));	\
		__foo_;						\
	})

/* Returns the current r31 */
#define current_sp						\
	({							\
		int *__foo_;					\
		asm("or %0, r0, r31" : "=r" (__foo_));	\
		__foo_;						\
	})

/* Returns the current r30 */
#define current_fp						\
	({							\
		int *__foo_;					\
		asm("or %0, r0, r30" : "=r" (__foo_));	\
		__foo_;						\
	})

/* Returns the current r1 */
#define current_r1						\
	({							\
		int *__foo_;					\
		asm("or %0, r0, r1" : "=r" (__foo_));	\
		__foo_;						\
	})

#define current_xip						\
	({							\
		void (*__foo_)();				\
		asm("bsr 1f\n1: or %0, r0, r1" : "=r" (__foo_) ::"r1");	\
		__foo_;						\
	})

#endif /* __asm_h_included__ */
