#if 0 /* I guess unused.... */
/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	mem.c,v $
 * Revision 2.3  92/05/21  17:20:23  jfriedl
 * 	some cleanup.
 * 	[92/05/21  16:11:33  jfriedl]
 * 
 * Revision 2.2  91/07/09  23:18:48  danner
 * 	Initial Checkin
 * 	[91/06/26  12:29:15  danner]
 * 
 * Revision 2.3  91/04/05  14:03:52  mbj
 * 	Initial code from the Omron 1.10 kernel release corresponding to X130.
 * 	The Copyright has been adjusted to correspond to the understanding
 * 	between CMU and the Omron Corporation.
 * 	[91/04/04            rvb]
 * 
 */

/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)mem.c	7.1 (Berkeley) 6/5/86
 */

#include <mach_load.h>

/*
 * Memory special file
 */

#include <luna88k/pte.h>

#include <sys/param.h>
#include <sys/dir.h>
#include <sys/user.h>
#include <sys/conf.h>
#include <sys/buf.h>
#include <sys/systm.h>
#include <sys/vm.h>
#include <sys/uio.h>


#include <vm/vm_map.h>
#include <vm/vm_kern.h>
#include <mach/vm_param.h>

extern int loadpt; 

mmread(dev, uio)
	dev_t dev;
	struct uio *uio;
{

	return (mmrw(dev, uio, UIO_READ));
}

mmwrite(dev, uio)
	dev_t dev;
	struct uio *uio;
{

	return (mmrw(dev, uio, UIO_WRITE));
}

mmrw(dev, uio, rw)
	dev_t dev;
	struct uio *uio;
	enum uio_rw rw;
{
	register int o;
	register u_int c, v;
	register struct iovec *iov;
	int error = 0;
	vm_offset_t	where;
	int		spl;


	while (uio->uio_resid > 0 && error == 0) {
		iov = uio->uio_iov;
		if (iov->iov_len == 0) {
			uio->uio_iov++;
			uio->uio_iovcnt--;
			if (uio->uio_iovcnt < 0)
				panic("mmrw");
			continue;
		}
		switch (minor(dev)) {

/* minor device 0 is physical memory */
		case 0:
#if	MACH_LOAD
			v = trunc_page(uio->uio_offset + loadpt);
#else	MACH_LOAD
			v = trunc_page(uio->uio_offset);
#endif	MACH_LOAD
			if (uio->uio_offset >= mem_size)
				goto fault;

			spl = splvm();
			where = vm_map_min(kernel_map);
			if (vm_map_find(kernel_map, VM_OBJECT_NULL,
				(vm_offset_t) 0, &where, PAGE_SIZE, TRUE) != KERN_SUCCESS) {
				splx(spl);
				goto fault;
			}
			pmap_enter(vm_map_pmap(kernel_map), where, v,
					VM_PROT_READ|VM_PROT_WRITE, FALSE);
			pmap_update();
#if	MACH_LOAD
			o = (uio->uio_offset + loadpt) - v;
#else	MACH_LOAD
			o = uio->uio_offset - v;
#endif	MACH_LOAD
			c = min(PAGE_SIZE - o, (u_int)iov->iov_len);
			error = uiomove((caddr_t) (where + o), c, rw, uio);
			vm_map_remove(kernel_map, where, where + PAGE_SIZE);
			splx(spl);
			continue;

/* minor device 1 is kernel memory */
		case 1:
			c = iov->iov_len;
			if (!kernacc((caddr_t)uio->uio_offset, c, rw == UIO_READ ? B_READ : B_WRITE))
				goto fault;
			error = uiomove((caddr_t)uio->uio_offset, (int)c, rw, uio);
			continue;

/* minor device 2 is EOF/RATHOLE */
		case 2:
			if (rw == UIO_READ)
				return (0);
			c = iov->iov_len;
			break;
		}
		if (error)
			break;
		iov->iov_base += c;
		iov->iov_len -= c;
		uio->uio_offset += c;
		uio->uio_resid -= c;
	}
	return (error);
fault:
	return (EFAULT);
}
#endif 0
