/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	scr.h,v $
 * Revision 2.2  91/07/09  23:19:34  danner
 * 	Initial Checkin
 * 	[91/06/26  12:31:46  danner]
 * 
 * Revision 2.2  91/04/05  14:05:00  mbj
 * 	Initial code from the Omron 1.10 kernel release corresponding to X130.
 * 	The Copyright has been adjusted to correspond to the understanding
 * 	between CMU and the Omron Corporation.
 * 	[91/04/04            rvb]
 * 
 */

#define PID	0	/* cr0 */
#define PSR	1	/* cr1 */
#define EPSR	2	/* cr2 */
#define SSBR	3	/* cr3 */
#define SXIP	4	/* cr4 */
#define SNIP	5	/* cr5 */
#define SFIP	6	/* cr6 */
#define VBR	7	/* cr7 */
#define DMT0	8	/* cr8 */
#define DMD0	9	/* cr9 */
#define DMA0	10	/* cr10 */
#define DMT1	11	/* cr11 */
#define DMD1	12	/* cr12 */
#define DMA1	13	/* cr13 */
#define DMT2	14	/* cr14 */
#define DMD2	15	/* cr15 */
#define DMA2	16	/* cr16 */
#define SR0	17	/* cr17 */
#define SR1	18	/* cr18 */
#define SR2	19	/* cr19 */
#define SR3	20	/* cr20 */
#define FPECR	21	/* fcr0 */
#define FPHS1	22	/* fcr1 */
#define FPLS1	23	/* fcr2 */
#define FPHS2	24	/* fcr3 */
#define FPLS2	25	/* fcr4 */
#define FPPT	26	/* fcr5 */
#define FPRH	27	/* fcr6 */
#define FPRL	28	/* fcr7 */
#define FPIT	29	/* fcr8 */
#define FPSR	30	/* fcr62 */
#define FPCR	31	/* fcr63 */
