/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	setjmp.h,v $
 * Revision 2.2  91/07/09  23:19:36  danner
 * 	Initial 3.0 Checkin.
 * 	[91/07/09  09:55:58  danner]
 * 
 * Revision 2.2  91/04/05  14:05:08  mbj
 * 	Initial code from the Omron 1.10 kernel release corresponding to X130.
 * 	The Copyright has been adjusted to correspond to the understanding
 * 	between CMU and the Omron Corporation.
 * 	[91/04/04            rvb]
 * 
 */

/*
 * Setjmp buffer for luna. Defined for ddb's sake.
 *
 */

#ifndef _LUNA_SETJMP_H_
#define _LUNA_SETJMP_H_ 1

/* 
  This needs to be kept in sync with setjmp/longjmp in 
  luna/locore_asm_routines.c . The 88100 reference indicates that
  registers r2 - r9 are for called procedure parameters and
  r10 - r13 are scratch registers, so they don't/shouldn't be saved.
  All other gpr's should be. This leaves 19 registers (r0, the constant
  zero register doesn't need to be saved) to be stored.
 */

typedef struct jmp_buf 
{
  int  jmp_buf[19];    
} jmp_buf_t;

#endif  _LUNA_SETJMP_H_


