/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	codetbl.h,v $
 * Revision 2.2  92/08/03  17:45:15  jfriedl
 * 	renamed from .t file
 * 	[92/07/24            jfriedl]
 * 
 */

/***********************/
/*                     */
/*  CODE HENKAN TABLE  */
/*                     */
/***********************/


/*************/
/*           */
/*  SPECIAL  */
/*           */
/*************/


static short t_specl[CODTBSZ] = 
{
    /* -- 00 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+ESCLINK+NOTREPT+TNORMAL,        /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    NG+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    NG+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    NG+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */
    
    /* -- 20 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL+'1',
    NG+NOTESCL+REPEATB+TNORMAL+'2',
    NG+NOTESCL+REPEATB+TNORMAL+'3',
    NG+NOTESCL+REPEATB+TNORMAL+'4',
    NG+NOTESCL+REPEATB+TNORMAL+'5',
    NG+NOTESCL+REPEATB+TNORMAL+'6',
    NG+NOTESCL+REPEATB+TNORMAL+'7',
    NG+NOTESCL+REPEATB+TNORMAL+'8',
    NG+NOTESCL+REPEATB+TNORMAL+'9',
    NG+NOTESCL+REPEATB+TNORMAL+'0',
    NG+NOTESCL+REPEATB+TNORMAL+'-',
    NG+NOTESCL+REPEATB+TNORMAL+'^',
    NG+NOTESCL+REPEATB+TNORMAL+0x5c,   /* \\ */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 30 -- */ 
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL+'q',
    NG+NOTESCL+REPEATB+TNORMAL+'w',
    NG+NOTESCL+REPEATB+TNORMAL+'e',
    NG+NOTESCL+REPEATB+TNORMAL+'r',
    NG+NOTESCL+REPEATB+TNORMAL+'t',
    NG+NOTESCL+REPEATB+TNORMAL+'y',
    NG+NOTESCL+REPEATB+TNORMAL+'u',
    NG+NOTESCL+REPEATB+TNORMAL+'i',
    NG+NOTESCL+REPEATB+TNORMAL+'o',
    NG+NOTESCL+REPEATB+TNORMAL+'p',
    NG+NOTESCL+REPEATB+TNORMAL+'@',
    NG+NOTESCL+REPEATB+TNORMAL+'[',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 40 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL+'a',
    NG+NOTESCL+REPEATB+TNORMAL+'s',
    NG+NOTESCL+REPEATB+TNORMAL+'d',
    NG+NOTESCL+REPEATB+TNORMAL+'f',
    NG+NOTESCL+REPEATB+TNORMAL+'g',
    NG+NOTESCL+REPEATB+TNORMAL+'h',
    NG+NOTESCL+REPEATB+TNORMAL+'j',
    NG+NOTESCL+REPEATB+TNORMAL+'k',
    NG+NOTESCL+REPEATB+TNORMAL+'l',
    NG+NOTESCL+REPEATB+TNORMAL+';',
    NG+NOTESCL+REPEATB+TNORMAL+':',
    NG+NOTESCL+REPEATB+TNORMAL+']',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 50 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL+'z',
    NG+NOTESCL+REPEATB+TNORMAL+'x',
    NG+NOTESCL+REPEATB+TNORMAL+'c',
    NG+NOTESCL+REPEATB+TNORMAL+'v',
    NG+NOTESCL+REPEATB+TNORMAL+'b',
    NG+NOTESCL+REPEATB+TNORMAL+'n',
    NG+NOTESCL+REPEATB+TNORMAL+'m',
    NG+NOTESCL+REPEATB+TNORMAL+',',
    NG+NOTESCL+REPEATB+TNORMAL+'.',
    NG+NOTESCL+REPEATB+TNORMAL+'/',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 60 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    NG+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 70 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    NG+ESCLINK+REPEATB+TKEYPAD         /* PF , */
	
    };

/*************/
/*           */
/*  CONTROL  */
/*           */
/*************/

static short t_cntrl[CODTBSZ] = 
{
    /* -- 00 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+ESCLINK+NOTREPT+TNORMAL,        /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    NG+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    NG+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x00,  /* NUL */
    NG+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    NG+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */
    
    /* -- 20 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL+'1',
    NG+NOTESCL+REPEATB+TNORMAL+'2',
    NG+NOTESCL+REPEATB+TNORMAL+'3',
    NG+NOTESCL+REPEATB+TNORMAL+'4',
    NG+NOTESCL+REPEATB+TNORMAL+'5',
    NG+NOTESCL+REPEATB+TNORMAL+'6',
    NG+NOTESCL+REPEATB+TNORMAL+'7',
    NG+NOTESCL+REPEATB+TNORMAL+'8',
    NG+NOTESCL+REPEATB+TNORMAL+'9',
    NG+NOTESCL+REPEATB+TNORMAL+'0',
    NG+NOTESCL+REPEATB+TNORMAL+'-',
    OK+NOTESCL+REPEATB+TNORMAL+0x1e,   /* RS */
    OK+NOTESCL+REPEATB+TNORMAL+0x1c,   /* FS */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 30 -- */ 

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x11,   /* DC1 or XON */
    OK+NOTESCL+REPEATB+TNORMAL+0x17,   /* ETB        */
    OK+NOTESCL+REPEATB+TNORMAL+0x05,   /* ENQ        */
    OK+NOTESCL+REPEATB+TNORMAL+0x12,   /* DC2        */
    OK+NOTESCL+REPEATB+TNORMAL+0x14,   /* DC4        */
    OK+NOTESCL+REPEATB+TNORMAL+0x19,   /* EM         */
    OK+NOTESCL+REPEATB+TNORMAL+0x15,   /* NAK        */
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* HT         */
    OK+NOTESCL+REPEATB+TNORMAL+0x0f,   /* SI         */
    OK+NOTESCL+REPEATB+TNORMAL+0x10,   /* DLE        */
    NG+NOTESCL+REPEATB+TNORMAL+'@',
    OK+NOTESCL+REPEATB+TNORMAL+0x1b,   /* ESC        */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 40 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x01,   /* SOH         */
    OK+NOTESCL+REPEATB+TNORMAL+0x13,   /* DC3 or XOFF */
    OK+NOTESCL+REPEATB+TNORMAL+0x04,   /* EOT         */
    OK+NOTESCL+REPEATB+TNORMAL+0x06,   /* ACK         */
    OK+NOTESCL+REPEATB+TNORMAL+0x07,   /* BELL        */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,   /* BS          */
    OK+NOTESCL+REPEATB+TNORMAL+0x0a,   /* LF          */
    OK+NOTESCL+REPEATB+TNORMAL+0x0b,   /* VT          */
    OK+NOTESCL+REPEATB+TNORMAL+0x0c,   /* FF          */
    NG+NOTESCL+REPEATB+TNORMAL+';',
    NG+NOTESCL+REPEATB+TNORMAL+':',
    OK+NOTESCL+REPEATB+TNORMAL+0x1d,   /* GS          */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 50 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x1a,   /* SUB */
    OK+NOTESCL+REPEATB+TNORMAL+0x18,   /* CAN */
    OK+NOTESCL+REPEATB+TNORMAL+0x03,   /* ETX */
    OK+NOTESCL+REPEATB+TNORMAL+0x16,   /* SYN */
    OK+NOTESCL+REPEATB+TNORMAL+0x02,   /* STX */
    OK+NOTESCL+REPEATB+TNORMAL+0x0e,   /* SO  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR  */
    NG+NOTESCL+REPEATB+TNORMAL+',',
    NG+NOTESCL+REPEATB+TNORMAL+'.',
    OK+NOTESCL+REPEATB+TNORMAL+0x1f,   /* US  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 60 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    NG+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 70 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    NG+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    NG+ESCLINK+REPEATB+TKEYPAD         /* PF , */
	      
    };

/********************/
/*                  */
/*  KANA  +  SHIFT  */
/*                  */
/********************/
static short t_kansf[CODTBSZ] = 
{
    /* -- 00 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */
    
    OK+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    OK+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */

    /* -- 20 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,     
    OK+NOTESCL+REPEATB+TNORMAL+0xa7,   /* small a      */
    OK+NOTESCL+REPEATB+TNORMAL+0xa9,   /* small u      */
    OK+NOTESCL+REPEATB+TNORMAL+0xaa,   /* small e      */
    OK+NOTESCL+REPEATB+TNORMAL+0xab,   /* small o      */
    OK+NOTESCL+REPEATB+TNORMAL+0xac,   /* small ya     */
    OK+NOTESCL+REPEATB+TNORMAL+0xad,   /* small yu     */
    OK+NOTESCL+REPEATB+TNORMAL+0xae,   /* small yo     */
    OK+NOTESCL+REPEATB+TNORMAL+0xa6,   /* wo           */
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,     
    NG+NOTESCL+REPEATB+TNORMAL,                 
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 30 -- */ 
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xa8,   /* small i      */
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xa2,   /* kagi kakko   */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 40 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xa3,   /* kagi kakko    */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 50 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xaf,  /* small tsu     */
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    NG+NOTESCL+REPEATB+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xa4,  /* kudokuten     */
    OK+NOTESCL+REPEATB+TNORMAL+0xdf,  /* kuten         */
    OK+NOTESCL+REPEATB+TNORMAL+0xa5,  /* dokuten       */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 60 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 70 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    OK+ESCLINK+REPEATB+TKEYPAD         /* PF , */
	
    };

/**********/
/*        */
/*  KANA  */
/*        */
/**********/

static short t_kana[CODTBSZ] = 
{
    /* -- 00 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */
    
    OK+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    OK+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */
    
    /* -- 20 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xc7,   /* nu           */
    OK+NOTESCL+REPEATB+TNORMAL+0xcc,   /* fu           */
    OK+NOTESCL+REPEATB+TNORMAL+0xb1,   /* a            */
    OK+NOTESCL+REPEATB+TNORMAL+0xb3,   /* u            */
    OK+NOTESCL+REPEATB+TNORMAL+0xb4,   /* e            */
    OK+NOTESCL+REPEATB+TNORMAL+0xb5,   /* o            */
    OK+NOTESCL+REPEATB+TNORMAL+0xd4,   /* ya           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd5,   /* yu           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd6,   /* yo           */
    OK+NOTESCL+REPEATB+TNORMAL+0xdc,   /* wa           */
    OK+NOTESCL+REPEATB+TNORMAL+0xce,   /* ho           */
    OK+NOTESCL+REPEATB+TNORMAL+0xcd,   /* he           */
    OK+NOTESCL+REPEATB+TNORMAL+0xb0,   /* -	         */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 30 -- */ 

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xc0,   /* ta           */
    OK+NOTESCL+REPEATB+TNORMAL+0xc3,   /* te           */
    OK+NOTESCL+REPEATB+TNORMAL+0xb2,   /* i            */
    OK+NOTESCL+REPEATB+TNORMAL+0xbd,   /* su           */
    OK+NOTESCL+REPEATB+TNORMAL+0xb6,   /* ka           */
    OK+NOTESCL+REPEATB+TNORMAL+0xdd,   /* n            */
    OK+NOTESCL+REPEATB+TNORMAL+0xc5,   /* na           */
    OK+NOTESCL+REPEATB+TNORMAL+0xc6,   /* ni           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd7,   /* ra           */
    OK+NOTESCL+REPEATB+TNORMAL+0xbe,   /* se           */
    OK+NOTESCL+REPEATB+TNORMAL+0xde,   /* dakuten      */
    OK+NOTESCL+REPEATB+TNORMAL+0xdf,   /* handakuten   */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 40 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xc1,   /* chi          */
    OK+NOTESCL+REPEATB+TNORMAL+0xc4,   /* to           */
    OK+NOTESCL+REPEATB+TNORMAL+0xbc,   /* shi          */
    OK+NOTESCL+REPEATB+TNORMAL+0xca,   /* ha           */
    OK+NOTESCL+REPEATB+TNORMAL+0xb7,   /* ki           */
    OK+NOTESCL+REPEATB+TNORMAL+0xb8,   /* ku           */
    OK+NOTESCL+REPEATB+TNORMAL+0xcf,   /* ma           */
    OK+NOTESCL+REPEATB+TNORMAL+0xc9,   /* no           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd8,   /* ri           */
    OK+NOTESCL+REPEATB+TNORMAL+0xda,	 /* re           */	
    OK+NOTESCL+REPEATB+TNORMAL+0xb9,	 /* ke           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd1,	 /* mu           */
    NG+NOTESCL+NOTREPT+TNORMAL,	 
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 50 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0xc2,	 /* tsu          */
    OK+NOTESCL+REPEATB+TNORMAL+0xbb,	 /* sa           */
    OK+NOTESCL+REPEATB+TNORMAL+0xbf,	 /* so           */
    OK+NOTESCL+REPEATB+TNORMAL+0xcb,	 /* hi           */
    OK+NOTESCL+REPEATB+TNORMAL+0xba,	 /* ko           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd0,	 /* mi           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd3,	 /* mo           */
    OK+NOTESCL+REPEATB+TNORMAL+0xc8,	 /* ne           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd9,	 /* ru           */
    OK+NOTESCL+REPEATB+TNORMAL+0xd2,	 /* me           */
    OK+NOTESCL+NOTREPT+TNORMAL+0xdb,	 /* ro           */
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 60 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 70 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    OK+ESCLINK+REPEATB+TKEYPAD         /* PF , */

    };

/**************************/
/*                        */
/*   CAPS LOCK  +  SHIFT  */
/*                        */
/**************************/

static short t_capsf[CODTBSZ] = 
{
    /* -- 00 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */

    /* -- 10 -- */
    
    OK+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    OK+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */

    /* -- 20 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'!', 
    OK+NOTESCL+REPEATB+TNORMAL+'"',
    OK+NOTESCL+REPEATB+TNORMAL+'#', 
    OK+NOTESCL+REPEATB+TNORMAL+'$',
    OK+NOTESCL+REPEATB+TNORMAL+'%', 
    OK+NOTESCL+REPEATB+TNORMAL+'&', 
    OK+NOTESCL+REPEATB+TNORMAL+'\'', 
    OK+NOTESCL+REPEATB+TNORMAL+'(', 
    OK+NOTESCL+REPEATB+TNORMAL+')', 
    NG+NOTESCL+REPEATB+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'=',
    OK+NOTESCL+REPEATB+TNORMAL+0x7e,    /* ~           */
    OK+NOTESCL+REPEATB+TNORMAL+'|',             
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 30 -- */ 

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'q',
    OK+NOTESCL+REPEATB+TNORMAL+'w',
    OK+NOTESCL+REPEATB+TNORMAL+'e',
    OK+NOTESCL+REPEATB+TNORMAL+'r',
    OK+NOTESCL+REPEATB+TNORMAL+'t',
    OK+NOTESCL+REPEATB+TNORMAL+'y',
    OK+NOTESCL+REPEATB+TNORMAL+'u',
    OK+NOTESCL+REPEATB+TNORMAL+'i',
    OK+NOTESCL+REPEATB+TNORMAL+'o',
    OK+NOTESCL+REPEATB+TNORMAL+'p',
    OK+NOTESCL+REPEATB+TNORMAL+'`',
    OK+NOTESCL+REPEATB+TNORMAL+'{',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 40 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'a',
    OK+NOTESCL+REPEATB+TNORMAL+'s',
    OK+NOTESCL+REPEATB+TNORMAL+'d',
    OK+NOTESCL+REPEATB+TNORMAL+'f',
    OK+NOTESCL+REPEATB+TNORMAL+'g',
    OK+NOTESCL+REPEATB+TNORMAL+'h',
    OK+NOTESCL+REPEATB+TNORMAL+'j',
    OK+NOTESCL+REPEATB+TNORMAL+'k',
    OK+NOTESCL+REPEATB+TNORMAL+'l',
    OK+NOTESCL+REPEATB+TNORMAL+'+',
    OK+NOTESCL+REPEATB+TNORMAL+'*',
    OK+NOTESCL+REPEATB+TNORMAL+'}',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 50 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'z',
    OK+NOTESCL+REPEATB+TNORMAL+'x',
    OK+NOTESCL+REPEATB+TNORMAL+'c',
    OK+NOTESCL+REPEATB+TNORMAL+'v',
    OK+NOTESCL+REPEATB+TNORMAL+'b',
    OK+NOTESCL+REPEATB+TNORMAL+'n',
    OK+NOTESCL+REPEATB+TNORMAL+'m',
    OK+NOTESCL+REPEATB+TNORMAL+'<',
    OK+NOTESCL+REPEATB+TNORMAL+'>',
    OK+NOTESCL+REPEATB+TNORMAL+'?',
    OK+NOTESCL+NOTREPT+TNORMAL+'_',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 60 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 70 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    OK+ESCLINK+REPEATB+TKEYPAD         /* PF , */
	
    };

/***************/
/*             */
/*  CAPS LOCK  */
/*             */
/***************/

static short t_cploc[CODTBSZ] = 
{
    /* -- 00 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */
    
    OK+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    OK+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */

    /* -- 20 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'1',
    OK+NOTESCL+REPEATB+TNORMAL+'2', 
    OK+NOTESCL+REPEATB+TNORMAL+'3',
    OK+NOTESCL+REPEATB+TNORMAL+'4', 
    OK+NOTESCL+REPEATB+TNORMAL+'5',
    OK+NOTESCL+REPEATB+TNORMAL+'6', 
    OK+NOTESCL+REPEATB+TNORMAL+'7',
    OK+NOTESCL+REPEATB+TNORMAL+'8',
    OK+NOTESCL+REPEATB+TNORMAL+'9',
    OK+NOTESCL+REPEATB+TNORMAL+'0',
    OK+NOTESCL+REPEATB+TNORMAL+'-',
    OK+NOTESCL+REPEATB+TNORMAL+'^',
    OK+NOTESCL+REPEATB+TNORMAL+0x5c,   /* \\ */
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 30 -- */ 

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'Q',
    OK+NOTESCL+REPEATB+TNORMAL+'W',
    OK+NOTESCL+REPEATB+TNORMAL+'E',
    OK+NOTESCL+REPEATB+TNORMAL+'R',
    OK+NOTESCL+REPEATB+TNORMAL+'T',
    OK+NOTESCL+REPEATB+TNORMAL+'Y',
    OK+NOTESCL+REPEATB+TNORMAL+'U',
    OK+NOTESCL+REPEATB+TNORMAL+'I',
    OK+NOTESCL+REPEATB+TNORMAL+'O',
    OK+NOTESCL+REPEATB+TNORMAL+'P',
    OK+NOTESCL+REPEATB+TNORMAL+'@',
    OK+NOTESCL+REPEATB+TNORMAL+'[',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 40 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'A',
    OK+NOTESCL+REPEATB+TNORMAL+'S',
    OK+NOTESCL+REPEATB+TNORMAL+'D',
    OK+NOTESCL+REPEATB+TNORMAL+'F',
    OK+NOTESCL+REPEATB+TNORMAL+'G',
    OK+NOTESCL+REPEATB+TNORMAL+'H',
    OK+NOTESCL+REPEATB+TNORMAL+'J',
    OK+NOTESCL+REPEATB+TNORMAL+'K',
    OK+NOTESCL+REPEATB+TNORMAL+'L',
    OK+NOTESCL+REPEATB+TNORMAL+';',
    OK+NOTESCL+REPEATB+TNORMAL+':',
    OK+NOTESCL+REPEATB+TNORMAL+']',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 50 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'Z',
    OK+NOTESCL+REPEATB+TNORMAL+'X',
    OK+NOTESCL+REPEATB+TNORMAL+'C',
    OK+NOTESCL+REPEATB+TNORMAL+'V',
    OK+NOTESCL+REPEATB+TNORMAL+'B',
    OK+NOTESCL+REPEATB+TNORMAL+'N',
    OK+NOTESCL+REPEATB+TNORMAL+'M',
    OK+NOTESCL+REPEATB+TNORMAL+',',
    OK+NOTESCL+REPEATB+TNORMAL+'.',
    OK+NOTESCL+REPEATB+TNORMAL+'/',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 60 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 70 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    OK+ESCLINK+REPEATB+TKEYPAD         /* PF , */

    };

/***********/
/*         */
/*  SHIFT  */
/*         */
/***********/

static short t_shift[CODTBSZ] = 
{
    /* -- 00 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */

    OK+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    OK+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */

    /* -- 20 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'!', 
    OK+NOTESCL+REPEATB+TNORMAL+'"',
    OK+NOTESCL+REPEATB+TNORMAL+'#', 
    OK+NOTESCL+REPEATB+TNORMAL+'$',
    OK+NOTESCL+REPEATB+TNORMAL+'%', 
    OK+NOTESCL+REPEATB+TNORMAL+'&', 
    OK+NOTESCL+REPEATB+TNORMAL+'\'', 
    OK+NOTESCL+REPEATB+TNORMAL+'(', 
    OK+NOTESCL+REPEATB+TNORMAL+')', 
    NG+NOTESCL+REPEATB+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'=',
    OK+NOTESCL+REPEATB+TNORMAL+0x7e,    /* ~           */
    OK+NOTESCL+REPEATB+TNORMAL+'|',             
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 30 -- */ 

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'Q',
    OK+NOTESCL+REPEATB+TNORMAL+'W',
    OK+NOTESCL+REPEATB+TNORMAL+'E',
    OK+NOTESCL+REPEATB+TNORMAL+'R',
    OK+NOTESCL+REPEATB+TNORMAL+'T',
    OK+NOTESCL+REPEATB+TNORMAL+'Y',
    OK+NOTESCL+REPEATB+TNORMAL+'U',
    OK+NOTESCL+REPEATB+TNORMAL+'I',
    OK+NOTESCL+REPEATB+TNORMAL+'O',
    OK+NOTESCL+REPEATB+TNORMAL+'P',
    OK+NOTESCL+REPEATB+TNORMAL+'`',
    OK+NOTESCL+REPEATB+TNORMAL+'{',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 40 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'A',
    OK+NOTESCL+REPEATB+TNORMAL+'S',
    OK+NOTESCL+REPEATB+TNORMAL+'D',
    OK+NOTESCL+REPEATB+TNORMAL+'F',
    OK+NOTESCL+REPEATB+TNORMAL+'G',
    OK+NOTESCL+REPEATB+TNORMAL+'H',
    OK+NOTESCL+REPEATB+TNORMAL+'J',
    OK+NOTESCL+REPEATB+TNORMAL+'K',
    OK+NOTESCL+REPEATB+TNORMAL+'L',
    OK+NOTESCL+REPEATB+TNORMAL+'+',
    OK+NOTESCL+REPEATB+TNORMAL+'*',
    OK+NOTESCL+REPEATB+TNORMAL+'}',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 50 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'Z',
    OK+NOTESCL+REPEATB+TNORMAL+'X',
    OK+NOTESCL+REPEATB+TNORMAL+'C',
    OK+NOTESCL+REPEATB+TNORMAL+'V',
    OK+NOTESCL+REPEATB+TNORMAL+'B',
    OK+NOTESCL+REPEATB+TNORMAL+'N',
    OK+NOTESCL+REPEATB+TNORMAL+'M',
    OK+NOTESCL+REPEATB+TNORMAL+'<',
    OK+NOTESCL+REPEATB+TNORMAL+'>',
    OK+NOTESCL+REPEATB+TNORMAL+'?',
    OK+NOTESCL+NOTREPT+TNORMAL+'_',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 60 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,

    /* -- 70 -- */

    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    OK+ESCLINK+REPEATB+TKEYPAD         /* PF , */

    };

/************/
/*          */
/*  NORMAL  */
/*          */
/************/

static short t_nomal[CODTBSZ] = 
{
    /* -- 00 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+0x09,   /* TAB   */
    NG+ESCLINK+NOTREPT+THYOKYA,        /* CTRL  */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* kana  */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* shift */
    NG+NOTESCL+NOTREPT+THYOKYB,        /* CAP    */
    NG+NOTESCL+NOTREPT+THYOKYA,        /* special */
    
    /* -- 10 -- */
    
    OK+NOTESCL+NOTREPT+TNORMAL+0x1b,  /* ESC */
    OK+NOTESCL+REPEATB+TNORMAL+0x08,  /* BS  */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,  /* CR  */
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+' ',   /* space */
    OK+NOTESCL+REPEATB+TNORMAL+0x7f,  /* DEL */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe0,  /* henkan */
    OK+NOTESCL+NOTREPT+TNORMAL+0xe1,  /* kakutei */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF11 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF12 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF13 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF14 */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol up    */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol left  */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol right */
    OK+ESCLINK+REPEATB+TCURSOL,        /* cursol down  */
    
    /* -- 20 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'1',
    OK+NOTESCL+REPEATB+TNORMAL+'2',
    OK+NOTESCL+REPEATB+TNORMAL+'3',
    OK+NOTESCL+REPEATB+TNORMAL+'4',
    OK+NOTESCL+REPEATB+TNORMAL+'5',
    OK+NOTESCL+REPEATB+TNORMAL+'6',
    OK+NOTESCL+REPEATB+TNORMAL+'7',
    OK+NOTESCL+REPEATB+TNORMAL+'8',
    OK+NOTESCL+REPEATB+TNORMAL+'9',
    OK+NOTESCL+REPEATB+TNORMAL+'0',
    OK+NOTESCL+REPEATB+TNORMAL+'-',
    OK+NOTESCL+REPEATB+TNORMAL+'^',
    OK+NOTESCL+REPEATB+TNORMAL+0x5c,   /* \\ */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 30 -- */ 
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'q',
    OK+NOTESCL+REPEATB+TNORMAL+'w',
    OK+NOTESCL+REPEATB+TNORMAL+'e',
    OK+NOTESCL+REPEATB+TNORMAL+'r',
    OK+NOTESCL+REPEATB+TNORMAL+'t',
    OK+NOTESCL+REPEATB+TNORMAL+'y',
    OK+NOTESCL+REPEATB+TNORMAL+'u',
    OK+NOTESCL+REPEATB+TNORMAL+'i',
    OK+NOTESCL+REPEATB+TNORMAL+'o',
    OK+NOTESCL+REPEATB+TNORMAL+'p',
    OK+NOTESCL+REPEATB+TNORMAL+'@',
    OK+NOTESCL+REPEATB+TNORMAL+'[',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 40 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'a',
    OK+NOTESCL+REPEATB+TNORMAL+'s',
    OK+NOTESCL+REPEATB+TNORMAL+'d',
    OK+NOTESCL+REPEATB+TNORMAL+'f',
    OK+NOTESCL+REPEATB+TNORMAL+'g',
    OK+NOTESCL+REPEATB+TNORMAL+'h',
    OK+NOTESCL+REPEATB+TNORMAL+'j',
    OK+NOTESCL+REPEATB+TNORMAL+'k',
    OK+NOTESCL+REPEATB+TNORMAL+'l',
    OK+NOTESCL+REPEATB+TNORMAL+';',
    OK+NOTESCL+REPEATB+TNORMAL+':',
    OK+NOTESCL+REPEATB+TNORMAL+']',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 50 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+NOTESCL+REPEATB+TNORMAL+'z',
    OK+NOTESCL+REPEATB+TNORMAL+'x',
    OK+NOTESCL+REPEATB+TNORMAL+'c',
    OK+NOTESCL+REPEATB+TNORMAL+'v',
    OK+NOTESCL+REPEATB+TNORMAL+'b',
    OK+NOTESCL+REPEATB+TNORMAL+'n',
    OK+NOTESCL+REPEATB+TNORMAL+'m',
    OK+NOTESCL+REPEATB+TNORMAL+',',
    OK+NOTESCL+REPEATB+TNORMAL+'.',
    OK+NOTESCL+REPEATB+TNORMAL+'/',
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 60 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD + */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD - */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD 0 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* KEYPAD . */
    OK+NOTESCL+NOTREPT+TNORMAL+0x0d,   /* CR       */
    NG+NOTESCL+NOTREPT+TNORMAL,
    
    /* -- 70 -- */
    
    NG+NOTESCL+NOTREPT+TNORMAL,
    NG+NOTESCL+NOTREPT+TNORMAL,
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF1 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF2 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF3 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF4 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF5 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF6 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF7 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF8 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF9 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF10 */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF * */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF / */
    OK+ESCLINK+REPEATB+TKEYPAD,        /* PF = */
    OK+ESCLINK+REPEATB+TKEYPAD         /* PF , */
	
    };


