/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	esctbl.h,v $
 * Revision 2.2  92/08/03  17:45:52  jfriedl
 * 	renamed from .t file
 * 	[92/07/24            jfriedl]
 * 
 */

/*              */
/*  MODE TABLE  */
/*              */

static short t_mode[MODTBSZ] = 
{
    ARST,      /* cursol key   */
    ANSIKNM,   /* keypad key   */
    0x0000,    /* dummy        */
    0x0000,    /* dummy        */
    0x0000,    /* dummy        */
    0x0000,    /* dummy        */
    0x0000     /* dummy        */
    };

/*                */
/*  ESCAPE TABLE  */
/*                */

static unsigned char t_escap[ESCTSIZ][ESCSIZE] =
{
    /* PF11 */
    { 0x18,VT52KNM,0x1b,'a',ENDCODE },      /* ESCa  */
    { 0x18,VT52KAM,0x1b,'a',ENDCODE },      /* ESCa  */
    { 0x18,ANSIKNM,0x1b,'O','a',ENDCODE },  /* ESCOa */
    { 0x18,ANSIKAM,0x1b,'O','a',ENDCODE },  /* ESCOa */
    /* PF12 */
    { 0x19,VT52KNM,0x1b,'b',ENDCODE },      /* ESCb  */
    { 0x19,VT52KAM,0x1b,'b',ENDCODE },      /* ESCb  */
    { 0x19,ANSIKNM,0x1b,'O','b',ENDCODE },  /* ESCOb */
    { 0x19,ANSIKAM,0x1b,'O','b',ENDCODE },  /* ESCOb */
    /* PF13 */
    { 0x1a,VT52KNM,0x1b,'c',ENDCODE },      /* ESCc  */
    { 0x1a,VT52KAM,0x1b,'c',ENDCODE },      /* ESCc  */
    { 0x1a,ANSIKNM,0x1b,'O','c',ENDCODE },  /* ESCOc */
    { 0x1a,ANSIKAM,0x1b,'O','c',ENDCODE },  /* ESCOc */
    /* PF14 */
    { 0x1b,VT52KNM,0x1b,'d',ENDCODE },      /* ESCd  */
    { 0x1b,VT52KAM,0x1b,'d',ENDCODE },      /* ESCd  */
    { 0x1b,ANSIKNM,0x1b,'O','d',ENDCODE },  /* ESCOd */
    { 0x1b,ANSIKAM,0x1b,'O','d',ENDCODE },  /* ESCOd */
    /* cursol up */
    { 0x1c,VT52,0x1b,'A',ENDCODE  },        /* ESCA  */
    { 0x1c,ARST,0x1b,'[','A',ENDCODE },     /* ESC[A */
    { 0x1c,ASET,0x1b,'O','A',ENDCODE },     /* ESCOA */
    /* cursol left */
    { 0x1d,VT52,0x1b,'D',ENDCODE  },        /* ESCD  */
    { 0x1d,ARST,0x1b,'[','D',ENDCODE },     /* ESC[D */
    { 0x1d,ASET,0x1b,'O','D',ENDCODE },     /* ESCOD */
    /* cursol right */
    { 0x1e,VT52,0x1b,'C',ENDCODE  },        /* ESCC  */
    { 0x1e,ARST,0x1b,'[','C',ENDCODE },     /* ESC[C */
    { 0x1e,ASET,0x1b,'O','C',ENDCODE },     /* ESCOC */
    /* cursol down */
    { 0x1f,VT52,0x1b,'B',ENDCODE  },        /* ESCB  */
    { 0x1f,ARST,0x1b,'[','B',ENDCODE },     /* ESC[B */
    { 0x1f,ASET,0x1b,'O','B',ENDCODE },     /* ESCOB */
    /* + key */
    { 0x61,VT52KNM,'+',ENDCODE },
    { 0x61,VT52KAM,0x1b,'?','h',ENDCODE },  /* ESC?h */
    { 0x61,ANSIKNM,'+',ENDCODE },
    { 0x61,ANSIKAM,0x1b,'O','h',ENDCODE },  /* ESCOh */
    /* - key */  
    { 0x62,VT52KNM,'-',ENDCODE },
    { 0x62,VT52KAM,0x1b,'?','m',ENDCODE },  /* ESC?m */
    { 0x62,ANSIKNM,'-',ENDCODE },
    { 0x62,ANSIKAM,0x1b,'O','m',ENDCODE },  /* ESCOm */
    /* 7 key */
    { 0x63,VT52KNM,'7',ENDCODE },
    { 0x63,VT52KAM,0x1b,'?','w',ENDCODE },  /* ESC?w */
    { 0x63,ANSIKNM,'7',ENDCODE },
    { 0x63,ANSIKAM,0x1b,'O','w',ENDCODE },  /* ESCOw */
    /* 8 key */
    { 0x64,VT52KNM,'8',ENDCODE },
    { 0x64,VT52KAM,0x1b,'?','x',ENDCODE },  /* ESC?x */
    { 0x64,ANSIKNM,'8',ENDCODE },
    { 0x64,ANSIKAM,0x1b,'O','x',ENDCODE },  /* ESCOx */
    /* 9 key */
    { 0x65,VT52KNM,'9',ENDCODE },
    { 0x65,VT52KAM,0x1b,'?','y',ENDCODE },  /* ESC?y */
    { 0x65,ANSIKNM,'9',ENDCODE },
    { 0x65,ANSIKAM,0x1b,'O','y',ENDCODE },  /* ESCOy */
    /* 4 key */
    { 0x66,VT52KNM,'4',ENDCODE },
    { 0x66,VT52KAM,0x1b,'?','t',ENDCODE },  /* ESC?t */
    { 0x66,ANSIKNM,'4',ENDCODE },
    { 0x66,ANSIKAM,0x1b,'O','t',ENDCODE },  /* ESCOt */
    /* 5 key */
    { 0x67,VT52KNM,'5',ENDCODE },
    { 0x67,VT52KAM,0x1b,'?','u',ENDCODE },  /* ESC?u */
    { 0x67,ANSIKNM,'5',ENDCODE },
    { 0x67,ANSIKAM,0x1b,'O','u',ENDCODE },  /* ESCOu */
    /* 6 key */
    { 0x68,VT52KNM,'6',ENDCODE },
    { 0x68,VT52KAM,0x1b,'?','v',ENDCODE },  /* ESC?v */
    { 0x68,ANSIKNM,'6',ENDCODE },
    { 0x68,ANSIKAM,0x1b,'O','v',ENDCODE },  /* ESCOv */
    /* 1 key */
    { 0x69,VT52KNM,'1',ENDCODE },
    { 0x69,VT52KAM,0x1b,'?','q',ENDCODE },  /* ESC?q */
    { 0x69,ANSIKNM,'1',ENDCODE },
    { 0x69,ANSIKAM,0x1b,'O','q',ENDCODE },  /* ESCOq */
    /* 2 key */
    { 0x6a,VT52KNM,'2',ENDCODE },
    { 0x6a,VT52KAM,0x1b,'?','r',ENDCODE },  /* ESC?r */
    { 0x6a,ANSIKNM,'2',ENDCODE },
    { 0x6a,ANSIKAM,0x1b,'O','r',ENDCODE },  /* ESCOr */
    /* 3 key */
    { 0x6b,VT52KNM,'3',ENDCODE },
    { 0x6b,VT52KAM,0x1b,'?','s',ENDCODE },  /* ESC?s */
    { 0x6b,ANSIKNM,'3',ENDCODE },
    { 0x6b,ANSIKAM,0x1b,'O','s',ENDCODE },  /* ESCOs */
    /* 0 key */
    { 0x6c,VT52KNM,'0',ENDCODE },
    { 0x6c,VT52KAM,0x1b,'?','p',ENDCODE },  /* ESC?p */
    { 0x6c,ANSIKNM,'0',ENDCODE },
    { 0x6c,ANSIKAM,0x1b,'O','p',ENDCODE },  /* ESCOp */
    /* . key */
    { 0x6d,VT52KNM,'.',ENDCODE },
    { 0x6d,VT52KAM,0x1b,'?','n',ENDCODE },  /* ESC?n */
    { 0x6d,ANSIKNM,'.',ENDCODE },
    { 0x6d,ANSIKAM,0x1b,'O','n',ENDCODE },  /* ESCOn */
    /* PF1  */
    { 0x72,VT52KNM,0x1b,'P',ENDCODE },      /* ESCP  */
    { 0x72,VT52KAM,0x1b,'P',ENDCODE },      /* ESCP  */
    { 0x72,ANSIKNM,0x1b,'O','P',ENDCODE },  /* ESCOP */
    { 0x72,ANSIKAM,0x1b,'O','P',ENDCODE },  /* ESCOP */
    /* PF2  */
    { 0x73,VT52KNM,0x1b,'Q',ENDCODE },      /* ESCQ  */
    { 0x73,VT52KAM,0x1b,'Q',ENDCODE },      /* ESCQ  */
    { 0x73,ANSIKNM,0x1b,'O','Q',ENDCODE },  /* ESCOQ */
    { 0x73,ANSIKAM,0x1b,'O','Q',ENDCODE },  /* ESCOQ */
    /* PF3  */
    { 0x74,VT52KNM,0x1b,'R',ENDCODE },      /* ESCR  */
    { 0x74,VT52KAM,0x1b,'R',ENDCODE },      /* ESCR  */
    { 0x74,ANSIKNM,0x1b,'O','R',ENDCODE },  /* ESCOR */
    { 0x74,ANSIKAM,0x1b,'O','R',ENDCODE },  /* ESCOR */
    /* PF4  */
    { 0x75,VT52KNM,0x1b,'S',ENDCODE },      /* ESCS  */
    { 0x75,VT52KAM,0x1b,'S',ENDCODE },      /* ESCS  */
    { 0x75,ANSIKNM,0x1b,'O','S',ENDCODE },  /* ESCOS */
    { 0x75,ANSIKAM,0x1b,'O','S',ENDCODE },  /* ESCOS */
    /* PF5  */
    { 0x76,VT52KNM,0x1b,'T',ENDCODE },      /* ESCT  */
    { 0x76,VT52KAM,0x1b,'T',ENDCODE },      /* ESCT  */
    { 0x76,ANSIKNM,0x1b,'O','T',ENDCODE },  /* ESCOT */
    { 0x76,ANSIKAM,0x1b,'O','T',ENDCODE },  /* ESCOT */
    /* PF6  */
    { 0x77,VT52KNM,0x1b,'U',ENDCODE },      /* ESCU  */
    { 0x77,VT52KAM,0x1b,'U',ENDCODE },      /* ESCU  */
    { 0x77,ANSIKNM,0x1b,'O','U',ENDCODE },  /* ESCOU */
    { 0x77,ANSIKAM,0x1b,'O','U',ENDCODE },  /* ESCOU */
    /* PF7  */
    { 0x78,VT52KNM,0x1b,'V',ENDCODE },      /* ESCV  */
    { 0x78,VT52KAM,0x1b,'V',ENDCODE },      /* ESCV  */
    { 0x78,ANSIKNM,0x1b,'O','V',ENDCODE },  /* ESCOV */
    { 0x78,ANSIKAM,0x1b,'O','V',ENDCODE },  /* ESCOV */
    /* PF8  */
    { 0x79,VT52KNM,0x1b,'W',ENDCODE },      /* ESCW  */
    { 0x79,VT52KAM,0x1b,'W',ENDCODE },      /* ESCW  */
    { 0x79,ANSIKNM,0x1b,'O','W',ENDCODE },  /* ESCOW */
    { 0x79,ANSIKAM,0x1b,'O','W',ENDCODE },  /* ESCOW */
    /* PF9  */
    { 0x7a,VT52KNM,0x1b,'X',ENDCODE },      /* ESCX  */
    { 0x7a,VT52KAM,0x1b,'X',ENDCODE },      /* ESCX  */
    { 0x7a,ANSIKNM,0x1b,'O','X',ENDCODE },  /* ESCOX */
    { 0x7a,ANSIKAM,0x1b,'O','X',ENDCODE },  /* ESCOX */
    /* PF10 */
    { 0x7b,VT52KNM,0x1b,'Y',ENDCODE },      /* ESCY  */
    { 0x7b,VT52KAM,0x1b,'Y',ENDCODE },      /* ESCY  */
    { 0x7b,ANSIKNM,0x1b,'O','Y',ENDCODE },  /* ESCOY */
    { 0x7b,ANSIKAM,0x1b,'O','Y',ENDCODE },  /* ESCOY */
    /* * key */ 
    { 0x7c,VT52KNM,'*',ENDCODE },
    { 0x7c,VT52KAM,0x1b,'?','i',ENDCODE },  /* ESC?i */
    { 0x7c,ANSIKNM,'*',ENDCODE },
    { 0x7c,ANSIKAM,0x1b,'O','i',ENDCODE },  /* ESCOi */
    /* / key */ 
    { 0x7d,VT52KNM,'/',ENDCODE },
    { 0x7d,VT52KAM,0x1b,'?','j',ENDCODE },  /* ESC?j */
    { 0x7d,ANSIKNM,'/',ENDCODE },
    { 0x7d,ANSIKAM,0x1b,'O','j',ENDCODE },  /* ESCOj */
    /* = key */ 
    { 0x7e,VT52KNM,'=',ENDCODE },
    { 0x7e,VT52KAM,0x1b,'?','k',ENDCODE },  /* ESC?k */
    { 0x7e,ANSIKNM,'=',ENDCODE },
    { 0x7e,ANSIKAM,0x1b,'O','k',ENDCODE },  /* ESCOk */
    /* , key */ 
    { 0x7f,VT52KNM,',',ENDCODE },
    { 0x7f,VT52KAM,0x1b,'?','n',ENDCODE },  /* ESC?n */
    { 0x7f,ANSIKNM,',',ENDCODE },
    { 0x7f,ANSIKAM,0x1b,'O','n',ENDCODE },  /* ESCOn */
    
    { 0xff,0xff,0xff,0xff,ENDCODE },        /* DUMMY */
    { 0xff,0xff,0xff,0xff,ENDCODE },
    { 0xff,0xff,0xff,0xff,ENDCODE },
    { 0xff,0xff,0xff,0xff,ENDCODE },
    
    { 0xff,0xff,0xff,0xff,ENDCODE },        /* DUMMY */
    { 0xff,0xff,0xff,0xff,ENDCODE },
    { 0xff,0xff,0xff,0xff,ENDCODE },
    { 0xff,0xff,0xff,0xff,ENDCODE }
};
