#ifdef MACH_KERNEL
typedef unsigned short int ushort;
#endif

/*
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * Copyright (c) 1991 OMRON Corporation
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON AND OMRON ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON AND OMRON DISCLAIM ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	kbms.h,v $
 * Revision 2.2  91/07/09  23:20:59  danner
 * 	Initial Checkin
 * 	[91/06/26  11:42:36  danner]
 * 
 * Revision 2.2  91/04/05  14:08:40  mbj
 * 	Initial code from the Omron 1.10 kernel release corresponding to X130.
 * 	The Copyright has been adjusted to correspond to the understanding
 * 	between CMU and the Omron Corporation.
 * 	[91/04/04            rvb]
 * 
 */

/*
 *  Keyboard and Mouse information
 */
#include <sys/ioctl.h>

#define TERM	2
#define KBD	1
#define CONSOLE	0

#define	MOUSE	0

#define	ENCODED		0
#define	SEMIENCODED	1
#define	KB_RAW		2

#define	IOCTYPE		0xff00	

#ifdef MACH_KERNEL

#define	KBBUZZER	_IO('K', 1)

#define	KBSETM		_IO('K', 2)
#define	KBRSTM		_IO('K', 3)

#define	KBREPTIM	_IOW('K', 4, struct kbrepeat)
#define	KBFLSH		_IO('K', 5)

#define	KBSETKTM	_IOW('K', 6, struct keyescmode)

#define	KBEGETT		_IOWR('K', 7, struct kbesget)
#define	KBEGETTA	_IOW('K', 8, struct kbesgeta)
#define	KBESETT		_IOW('K', 9, struct kbesget)
#define	KBESETTA	_IOW('K', 10, struct kbesgeta)

#define	KBGETESC	_IOW('K', 11, struct escentry)
#define	KBSETESC	_IOW('K', 12, struct escentry)

#define	KBSGETT		_IOWR('K', 13, struct kbssget)
#define	KBSGETTA	_IOW('K', 14, struct kbssgeta)
#define	KBSSETT		_IOW('K', 15, struct kbesget)
#define	KBSSETTA	_IOW('K', 16, struct kbssgeta)

#define	KBRSTENABLE	_IO('K', 17)
#define	RSTDISABLE		0
#define	RSTENABLE		1
#define	DISABLE			0
#define	ENABLE			1

#define KBCLICK         _IO('K', 18)
#define KBBELL          _IO('K', 19)

/* KBBELL ioctl arg */
#define K_TIME40	0x00    /* buzzer time  40msec */
#define K_TIME150	0x08    /* buzzer time 150msec */
#define K_TIME400	0x10    /* buzzer time 400msec */
#define K_TIME700	0x18    /* buzzer time 700msec */

#define K_HZ6000	0x00    /* buzzer 6000Hz */
#define K_HZ3000	0x01    /* buzzer 3000Hz */
#define K_HZ1500	0x02    /* buzzer 1500Hz */
#define K_HZ1000	0x03    /* buzzer 1000Hz */
#define K_HZ600		0x04    /* buzzer  600Hz */
#define K_HZ300		0x05    /* buzzer  300Hz */
#define K_HZ150		0x06    /* buzzer  150Hz */
#define K_HZ100		0x07    /* buzzer  100Hz */

#define KBCHMAP		_IOW('K', 20, char *)
#define KBGETMAP	_IOW('K', 21, char *)
#define KBSETKME	_IOW('K', 22, struct km_ent)
#define KBGETKME	_IOW('K', 23, struct km_ent)
#define KBSETTBL	_IOW('K', 24, short *[8])
#define KBEXCHBS	_IO('K', 25)

#else

#define	KBBUZZER	_IO(K, 1)

#define	KBSETM		_IO(K, 2)
#define	KBRSTM		_IO(K, 3)

#define	KBREPTIM	_IOW(K, 4, struct kbrepeat)
#define	KBFLSH		_IO(K, 5)

#define	KBSETKTM	_IOW(K, 6, struct keyescmode)

#define	KBEGETT		_IOWR(K, 7, struct kbesget)
#define	KBEGETTA	_IOW(K, 8, struct kbesgeta)
#define	KBESETT		_IOW(K, 9, struct kbesget)
#define	KBESETTA	_IOW(K, 10, struct kbesgeta)

#define	KBGETESC	_IOW(K, 11, struct escentry)
#define	KBSETESC	_IOW(K, 12, struct escentry)

#define	KBSGETT		_IOWR(K, 13, struct kbssget)
#define	KBSGETTA	_IOW(K, 14, struct kbssgeta)
#define	KBSSETT		_IOW(K, 15, struct kbesget)
#define	KBSSETTA	_IOW(K, 16, struct kbssgeta)

#define	KBRSTENABLE	_IO(K, 17)
#define	RSTDISABLE		0
#define	RSTENABLE		1
#define	DISABLE			0
#define	ENABLE			1

#define KBCLICK         _IO(K, 18)
#define KBBELL          _IO(K, 19)

/* KBBELL ioctl arg */
#define K_TIME40	0x00    /* buzzer time  40msec */
#define K_TIME150	0x08    /* buzzer time 150msec */
#define K_TIME400	0x10    /* buzzer time 400msec */
#define K_TIME700	0x18    /* buzzer time 700msec */

#define K_HZ6000	0x00    /* buzzer 6000Hz */
#define K_HZ3000	0x01    /* buzzer 3000Hz */
#define K_HZ1500	0x02    /* buzzer 1500Hz */
#define K_HZ1000	0x03    /* buzzer 1000Hz */
#define K_HZ600		0x04    /* buzzer  600Hz */
#define K_HZ300		0x05    /* buzzer  300Hz */
#define K_HZ150		0x06    /* buzzer  150Hz */
#define K_HZ100		0x07    /* buzzer  100Hz */

#define KBCHMAP		_IOW(K, 20, char *)
#define KBGETMAP	_IOW(K, 21, char *)
#define KBSETKME	_IOW(K, 22, struct km_ent)
#define KBGETKME	_IOW(K, 23, struct km_ent)
#define KBSETTBL	_IOW(K, 24, short *[8])
#define KBEXCHBS	_IO(K, 25)

#endif

struct km_ent {
    short ent;
    char  value;
};

struct kbentry {
    char	flags;
    unsigned char	code;
};

struct kbesget	{
    short	tblno;
    short	keycode;
    struct kbentry	kbentry;
};

struct kbesgeta {
    short	tblno;
    struct kbentry	*kbtblp;
};	

struct kbssget	{
    short	keycode;
    char	kbsrept;
};

struct kbssgeta {
    char	*kbsreptp;
};	

struct keyescmode {
    short	keytype;
    ushort	escmode;
};

struct escentry {
    ushort	keycode;
    ushort	escmode;
    char	*esctext;
};

struct kbrepeat {
    ushort	repstart;
    ushort	repinterval;
};

#define	KBNON	0
#define	KBRESET	-1
#define	KBBREAK	-2

#define	COORDINATE	0
#define	DELTA		1

#ifdef MACH_KERNEL

#define	MSDGET		_IOWR('M', 1, struct msdget)
#define	MSDGETA		_IOWR('M', 2, struct msdgeta)

#define	MSSMPLCLK	_IO('M', 3)

#define	MSSETMICK	_IO('M', 4)

#define	MSSETLIMT	_IOW('M', 5, struct mssetlimt)

#define	MSSETCRNT	_IOW('M', 6, struct mssetcrnt)
#define	MSSETMODE	_IO('M', 7)

#define	MSSETCURS	_IO('M', 8)

#define	MSCURSCLK	_IO('M', 9)

#define	MSGETCRFNT	_IOWR('M', 10, struct mssgetcrfnt)
#define	MSSETCRFNT	_IOWR('M', 11, struct mssgetcrfnt)

#define	MSDFLUSH	_IO('M', 12)

#define FIONBIO		_IOW('f',126, int)  /* in ioctl.h in 2.5 */

#else

#define	MSDGET		_IOWR(M, 1, struct msdget)
#define	MSDGETA		_IOWR(M, 2, struct msdgeta)

#define	MSSMPLCLK	_IO(M, 3)

#define	MSSETMICK	_IO(M, 4)

#define	MSSETLIMT	_IOW(M, 5, struct mssetlimt)

#define	MSSETCRNT	_IOW(M, 6, struct mssetcrnt)
#define	MSSETMODE	_IO(M, 7)

#define	MSSETCURS	_IO(M, 8)

#define	MSCURSCLK	_IO(M, 9)

#define	MSGETCRFNT	_IOWR(M, 10, struct mssgetcrfnt)
#define	MSSETCRFNT	_IOWR(M, 11, struct mssgetcrfnt)

#define	MSDFLUSH	_IO(M, 12)


#endif

#define	COORDEVNT	0
#define	BUTONEVNT	1
#define	LIMITEVNT	16

struct msdata	{
    ushort	time;
    short	type;
    union {
	struct {
	    short	X_coord;
	    short	Y_coord;
	    short	X_speed;
	    short	Y_speed;
	} coordinate;
	struct {
	    unsigned char  L_button;
	    unsigned char  M_button;
	    unsigned char  R_button;
	} button;
    } event;
};

struct msdget	{
    short	mode;
    short	retval;
    struct msdata	msdata;
};

struct msdgeta	{
    short	mode;
    short	retval;
    short	count;
    struct msdata	*msdatap;
};

struct mssetlimt	{
    short	mode;
    short	X_scoord;
    short	Y_scoord;
    short	X_ecoord;
    short	Y_ecoord;
};

struct mssetcrnt	{
    short	X_coord;
    short	Y_coord;
};

struct mssgetcrfnt	{
    short	font;
    char	*fontp;
};


