/* 
 * Mach Operating System
 * Copyright (c) 1991,1990,1989,1988,1987 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS 
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	exception.h,v $
 * Revision 2.2  91/07/09  23:21:34  danner
 * 	Created
 * 	[91/07/08  22:40:45  danner]
 * 
 * 	Rearranged.
 * 	[89/08/16            hattori]
 * 
 *
 *  2-Nov-87  David Golub (dbg) at Carnegie-Mellon University
 *	Created.
 *
 */

#ifndef	_MACHINE_EXCEPTION_
#define _MACHINE_EXCEPTION_

/*
 *	Bad Access
 */
#define EXC_M88K_MISALIGN		20
/* should not conflict with kernel return code */

/*
 *	Bad Instruction
 */
#define EXC_M88K_PRIV			1
#define EXC_M88K_UNIMP			2

/*
 *	Arithmetic
 */
#define EXC_M88K_DIVIDE			1
#define EXC_M88K_OVERFLOW		2
#define EXC_M88K_FLOAT_P		3
#define EXC_M88K_FLOAT_I		4

/*
 *	Software
 */
#define EXC_M88K_BOUND			1
#define EXC_M88K_RESTRAP		2

#endif	_MACHINE_EXCEPTION_
