/* 
 * Mach Operating System
 * Copyright (c) 1991, 1992 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon 
 * the rights to redistribute these changes.
 */

/*
 * HISTORY
 * $Log:	thread_status.h,v $
 * Revision 2.6  92/05/04  11:27:48  danner
 * 	Added define of LUNA88K_EXC_STATE_COUNT
 * 	[92/04/30  13:43:23  danner]
 * 
 * Revision 2.5  92/02/19  14:12:21  elf
 * 	Include m88100 thread status definitions.
 * 	[92/01/20            danner]
 * 
 * Revision 2.4  91/08/24  12:17:36  af
 * 	Typo correction.
 * 	[91/08/09  18:32:12  danner]
 * 	Completely reorganized. All the machine registers are now
 * 	 exportable. Broke the state up into two pieces - one contains
 * 	 the basic user registers + pc, and the other contains the rest
 * 	 of the machine state. Things are synchronized with the
 * 	 luna88k_saved_state structure in luna88k/thread.h so that block
 * 	 copies can be used. 
 * 	[91/08/07            danner]
 * 
 * Revision 2.3  91/07/11  11:01:17  danner
 * 	Copyright Fixes
 * 
 * Revision 2.2  91/07/08  16:59:05  danner
 * 	Initial Checkin
 * 	[91/06/26  12:40:20  danner]
 * 
 *
 */
/*
 *	File   : thread_status.h
 *      Author : Daniel Stodolsky
 *      Created: August, 1991
 *
 *	This file contains the structure definitions for the thread
 *	state as applied to the M88100 processor.
 */


#ifndef	_MACHINE_THREAD_STATE_
#define	_MACHINE_THREAD_STATE_

#include <motorola/m88k/m88100/thread_status.h>

/*
 *	luna88k_thread_state	basic machine state
 *				
 *      luna88k_exc_state       exception state
 *
 */

#define LUNA88K_THREAD_STATE	M88100_THREAD_STATE
#define LUNA88K_EXC_STATE       M88100_EXC_STATE

#define luna88k_thread_state m88100_thread_state
#define luna88k_exc_state    m88100_exc_state

#define	LUNA88K_THREAD_STATE_COUNT M88100_THREAD_STATE_COUNT
#define	LUNA88K_EXC_STATE_COUNT M88100_EXC_STATE_COUNT

#endif _MACHINE_THREAD_STATE_
