/* 
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon 
 * the rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	cpu_number.h,v $
 * Revision 2.2  92/02/18  18:03:15  elf
 * 	Created.
 * 	[92/01/21            danner]
 * 
 */

#ifndef	_M88K_CPU_NUMBER_
#define _M88K_CPU_NUMBER_
 
#ifdef	KERNEL
#include <cpus.h>
#include <platforms.h>


#if	NCPUS == 1
#define cpu_number()	(0)
#define	set_cpu_number(cpu)

#else	NCPUS == 1

#define cpu_number()						\
	({							\
		int __foo_;					\
		asm("ldcr %0, cr18\n\tclr %0, %0, 0<4>" : "=r" (__foo_));	\
		__foo_;						\
	})

#endif	NCPUS == 1

#endif KERNEL

#endif	_M88K_CPU_NUMBER_

