;  
;  Mach Operating System
;  Copyright (c) 1991, 1992 Carnegie Mellon University
;  All Rights Reserved.
;  
;  Permission to use, copy, modify and distribute this software and its
;  documentation is hereby granted, provided that both the copyright
;  notice and this permission notice appear in all copies of the
;  software, derivative works or modified versions, and any portions
;  thereof, and that both notices appear in supporting documentation.
;  
;  CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
;  CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
;  ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
;  
;  Carnegie Mellon requests users of this software to return to
;  
;   Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
;   School of Computer Science
;   Carnegie Mellon University
;   Pittsburgh PA 15213-3890
;  
;  any improvements or extensions that they make and grant Carnegie Mellon 
;  the rights to redistribute these changes.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  Author :   Daniel Stodolsky
;  Created:   August 1991
;  Standalone crt0.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; HISTORY
; $Log:	crt0.ss,v $
; Revision 2.4  92/04/01  10:56:33  rpd
; 	Leave some more space on the top of stack; compiler convention
; 	 has debugged code save arguments (8 words) above the callers sp.
; 	[92/03/20            danner]
; 
; Revision 2.3  92/02/22  14:25:09  elf
; 	ixed envp computation bug (pointed out by davide@cs.cmu.edu).
; 	[92/02/22            elf]
; 
; Revision 2.2  92/02/18  18:04:14  elf
; 	Corrected bug in getting argv in start.
; 	[92/01/29            danner]
; 
; 	Corrected serious typo.
; 	[92/01/20            danner]
; 
; Revision 2.1.1.1  91/09/19  16:57:16  danner
; 	The rcs config file got trashed, so this is being checked 
;       in original again.
; 
; Revision 2.1.1.1  91/08/25  16:37:53  danner
; 	Add comm statements to allow cthread_{init,exit}_routine to
; 	 resolve in the absence of the cthreads library.
; 	[91/08/22            danner]
; 
; 	Created.
; 	[91/08/20            danner]
; 
;


	text
	align 4

start:	global start
	ld	r2, r31, 0       ; get argc
	addu	r3, r31, 4       ; get argv
	lda	r4, r3[r2]       ; get envp
	addu	r4, r4, 4	 ; bump past end of argv
	subu	r31, r31, 0x60	 ; allocate stack space
	st	r1,  r31, 0x38
	st	r21, r31, 0x24
	st.d	r24, r31, 0x30
	st.d	r22, r31, 0x28
	or	r22, r0,  r2
	or	r21, r0,  r3
	or	r24, r0,  r4
	or.u	r13, r0,  hi16(_mach_init_routine)
	ld	r12, r13, lo16(_mach_init_routine)
	or.u	r13, r0,  hi16(__cthread_init_routine)
	ld	r25, r13, lo16(__cthread_init_routine)
	or.u	r13, r0,  hi16(__cthread_exit_routine)
	ld	r23, r13, lo16(__cthread_exit_routine)
	or.u	r13, r0,  hi16(_environ)
	bcnd.n	eq0, r12, 1f             
	st	r24, r13, lo16(_environ)
	jsr	r12             ; call mach_init_routine if != 0
1:	bcnd	eq0, r25, 2f
	jsr	r25             ; call cthread_init_routine if != 0
;
; The cthread_init_routine returns a stack pointer that we should
; switch to. Don't trust the alignment of pointer to a doubleword, however.
;
; We also need to leave 8 words (0x20) as an incoming argument save area
; in case the code is compiled with debugging on.
; 
;
	subu	r2,  r2, 0x28   ; Space for args + bit for alignment
	and	r31, r2, 0xfff8 ; mask off the low three bits (rounding down) 
				; replacing the sp.
2:	or	r2, r0, r22
	or	r3, r0, r21
	bsr.n	_main		; argc, argv, envp 
	or	r4, r0, r24
	bcnd.n	eq0, r23, 3f    ; cthread_exit_routine != 0 ?
	or	r11, r0, r2
	br	4f
	or	r12, r0,  r23
3:	or.u	r12, r0,  hi16(_exit)
	or	r12, r12, lo16(_exit)
4:	jsr.n	r12		; call exit or cthread_exit_routine
	or	r2,  r0,  r11
	ld	r1,  r31, 0x38  ; get return address
	ld	r21, r31, 0x24
	ld.d	r24, r31, 0x30
	ld.d	r22, r31, 0x28
	jmp.n	r1
	addu	r31, r31, 0x40

;
; these are here so that crt0 will link against files
; that do not use the cthread libraries.
; these will resolve to null in that case.
;
	comm	_mach_init_routine,4
	comm	__cthread_init_routine,4
	comm    __cthread_exit_routine,4

	data
_environ:	global _environ
	word	0


	
	